"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _express = _interopRequireDefault(require("express"));

var _chalk = _interopRequireDefault(require("chalk"));

var _url = _interopRequireDefault(require("url"));

var _address = require("address");

var _index = _interopRequireDefault(require("./index"));

var _choosePort = _interopRequireDefault(require("./utils/choosePort"));

var _openBrowser = _interopRequireDefault(require("./utils/openBrowser"));

var _tools = require("./utils/tools");

var _excluded = ["open", "port", "version"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var server = function server(_ref) {
  var open = _ref.open,
      port = _ref.port,
      version = _ref.version,
      options = _objectWithoutProperties(_ref, _excluded);

  var protocol = process.env.HTTPS === 'true' ? 'https' : 'http';
  var DEFAULT_PORT = port || 1024;
  var HOST = process.env.HOST || '0.0.0.0';
  (0, _choosePort["default"])(HOST, DEFAULT_PORT).then(function (port) {
    if (port == null) {
      return;
    }

    var server = (0, _express["default"])();
    new _index["default"](server, options);
    server.listen(port, HOST, function () {
      (0, _tools.printLogo)(version);
      console.log('Listen to: ');
      console.log('');
      console.log((0, _tools.warn)("Local:            ".concat(protocol, "://localhost:").concat(port)));
      console.log((0, _tools.warn)("On Your Network:  ".concat(protocol, "://").concat((0, _address.ip)(), ":").concat(port)));
      console.log('');
      console.log((0, _tools.warnbg)(' DM '), _chalk["default"].green("Server started successfully"));
      console.log('');
      open && (0, _openBrowser["default"])(_url["default"].format({
        protocol: protocol,
        // hostname: HOST,
        hostname: 'localhost',
        port: port,
        pathname: '/'
      }));
    });
  })["catch"](function (err) {
    if (err && err.message) {
      console.log(err.message);
    }

    process.exit(1);
  });
};

var _default = server;
exports["default"] = _default;
module.exports = exports.default;