"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createObject = void 0;

var _lodash = _interopRequireDefault(require("lodash.set"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var createObject = function createObject(data) {
  var arrayType = '';
  var arrayTypeMock = '';
  return data.reduce(function (r, _ref) {
    var field = _ref.field,
        type = _ref.type,
        mockSize = _ref.mockSize,
        mock = _ref.mock;
    var key = field;
    var value = '';

    if (mock) {
      value = mock;
    }

    if (type === '[Object]') {
      arrayType = field;
      arrayTypeMock = typeof mockSize === 'undefined' ? '' : '|' + mockSize;
    }

    if (arrayType !== '' && key.includes(arrayType)) {
      key = field.replace(new RegExp("(^".concat(arrayType, ")")), '$1' + arrayTypeMock + '[0]') + (typeof mockSize !== 'undefined' && arrayType !== field ? "|".concat(mockSize) : '');
    } else {
      arrayType = '';
      arrayTypeMock = '';
    }

    (0, _lodash["default"])(r, key, value);
    return r;
  }, {});
};

exports.createObject = createObject;