"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.winPath = exports.warnbg = exports.warn = exports.transferApiManageList = exports.printLogo = exports.outputError = exports.judge = exports.errorbg = exports.error = exports.dealPath = exports.createMockHandler = void 0;

var _chalk = _interopRequireDefault(require("chalk"));

var _mockjs = require("mockjs");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 *
 * 修正windon路径问题
 *
 * @param {*} path
 */
var winPath = function winPath(path) {
  return path.replace(/\\/g, '/');
};

exports.winPath = winPath;

var createMockHandler = function createMockHandler(value) {
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    if (typeof value === 'function') {
      value.apply(void 0, args);
    } else {
      args[1].json((0, _mockjs.mock)(value));
    }
  };
};
/**
 *
 * 提取方法以及路径
 *
 * @param {*} key
 */


exports.createMockHandler = createMockHandler;

var dealPath = function dealPath(key) {
  return key.split(' ').slice(0, 2).reverse().map(function (v) {
    return v.toLowerCase();
  });
};

exports.dealPath = dealPath;

var outputError = function outputError(error) {
  if (!error) return;
  var filePath = error.message.split(': ')[0];
  var relativeFilePath = filePath;
  var errors = error.stack.split('\n').filter(function (line) {
    return line.trim().indexOf('at ') !== 0;
  }).map(function (line) {
    return line.replace("".concat(filePath, ": "), '');
  });
  errors.splice(1, 0, ['']);
  console.log(_chalk["default"].red('Failed to parse mock config.'));
  console.log();
  console.log("Error in ".concat(relativeFilePath));
  console.log(errors.join('\n'));
  console.log();
};

exports.outputError = outputError;

var error = function error(str) {
  return _chalk["default"].red(" ".concat(str, " "));
};

exports.error = error;

var warn = function warn(str) {
  return _chalk["default"].cyan(" ".concat(str, " "));
};

exports.warn = warn;

var errorbg = function errorbg(str) {
  return _chalk["default"].bgRed(_chalk["default"].white(" ".concat(str, " ")));
};

exports.errorbg = errorbg;

var warnbg = function warnbg(str) {
  return _chalk["default"].bgCyan(_chalk["default"].white(" ".concat(str, " ")));
};

exports.warnbg = warnbg;

var judge = function judge(bool, str) {
  if (bool) console.log(str);
};

exports.judge = judge;

var printLogo = function printLogo(version) {
  console.log('');
  console.log('');
  console.log(warn("\n    \u2588\u2588\u2588\u2588\u2588\u2588\u2557 \u2588\u2588\u2588\u2557   \u2588\u2588\u2588\u2557\n    \u2588\u2588\u2554\u2550\u2550\u2588\u2588\u2557\u2588\u2588\u2588\u2588\u2557 \u2588\u2588\u2588\u2588\u2551\n    \u2588\u2588\u2551  \u2588\u2588\u2551\u2588\u2588\u2554\u2588\u2588\u2588\u2588\u2554\u2588\u2588\u2551\n    \u2588\u2588\u2551  \u2588\u2588\u2551\u2588\u2588\u2551\u255A\u2588\u2588\u2554\u255D\u2588\u2588\u2551\n    \u2588\u2588\u2588\u2588\u2588\u2588\u2554\u255D\u2588\u2588\u2551 \u255A\u2550\u255D \u2588\u2588\u2551\n    \u255A\u2550\u2550\u2550\u2550\u2550\u255D \u255A\u2550\u255D     \u255A\u2550\u255D   ".concat(warnbg(" v".concat(version, " ")), "\n    ")));
  console.log('');
};
/**
 * 转换 api-mange 的 api 清单
 * */


exports.printLogo = printLogo;

var transferApiManageList = function transferApiManageList(apiList) {
  return Object.entries(apiList).reduce(function (r, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        method = _ref2[0],
        apis = _ref2[1];

    return Object.entries(apis).reduce(function (r2, _ref3) {
      var _ref4 = _slicedToArray(_ref3, 2),
          apiName = _ref4[0],
          apiPath = _ref4[1];

      return _objectSpread(_objectSpread({}, r2), {}, _defineProperty({}, apiName, "".concat(method, " ").concat(apiPath)));
    }, r);
  }, {});
};

exports.transferApiManageList = transferApiManageList;